from m5config import *

def new(name):
    fup = FuncUnitPool(name)
    fup.FUList = \
        [FUDesc('IntALU', opList=[OpDesc('a', opClass='IntAlu')], count=6),
         FUDesc('IntMultDiv',
                opList=[OpDesc('a', opClass='IntMult', opLat=3),
                        OpDesc('b', opClass='IntDiv',
                               opLat=20, issueLat=19)],
                count=2),
         FUDesc('FP_ALU',
                opList=[OpDesc('a', opClass='FloatAdd', opLat=2),
                        OpDesc('b', opClass='FloatCmp', opLat=2),
                        OpDesc('c', opClass='FloatCvt', opLat=2)],
                count=4),
         FUDesc('FP_MultDiv',
                opList=[OpDesc('a', opClass='FloatMult', opLat=4),
                        OpDesc('b', opClass='FloatDiv',
                               opLat=12, issueLat=12),
                        OpDesc('c', opClass='FloatSqrt',
                               opLat=24, issueLat=24)],
                count=2),
         FUDesc('ReadPort', opList=[OpDesc('a', opClass='MemRead')],
                count=0),
         FUDesc('WritePort', opList=[OpDesc('a', opClass='MemWrite')],
                count=0),
         FUDesc('RdWrPort', opList=[OpDesc('a', opClass='MemRead'),
                                    OpDesc('b', opClass='MemWrite')],
                count=4)]
    return fup
